# -*- coding: utf-8 -*-
"""
Created on Thu Jul  5 12:17:30 2018

@author: Usuario
"""


from PyQt5.QtCore import QSettings
from PyQt5.QtWidgets import QAction, QFileDialog, QInputDialog, QWidget
from threading import Thread
from webcamROI import roiWindow

#%%
class myToolbarMenu(QWidget):
    """
    This will create a toolbar menu
    """
    
    def __init__(self, win, analog_control_signals):
        super().__init__()
        
        self.MainGuiWindow = win
        self.aos = analog_control_signals
        
        self.first_load(self.aos)
        self.incorporate_toolbar(self.MainGuiWindow, self.aos)
        
        self.createAosDict()
    
    def createAosDict(self):
        analogs = self.aos
        self.aosDicc = {}
        for i in range(len(analogs)):
            self.aosDicc[analogs[i].name] = analogs[i]
        
    def incorporate_toolbar(self, win, analog_control_signals):
    
        menubar = win.menuBar()
    
        saveAct = QAction('Save', win)        
        loadAct = QAction('Load', win)
        saveAsAct = QAction('Save as' , win)
        openFromAct = QAction('open from', win)
        
        win.statusBar()
        menubar = win.menuBar()
        fileMenu = menubar.addMenu('&File')
        
        fileMenu.addAction(saveAct)
        fileMenu.addAction(loadAct)
        fileMenu.addAction(saveAsAct)
        fileMenu.addAction(openFromAct)
        
        
        viewMenu = menubar.addMenu('Monitor')
        viewWebcams = QAction('View webcams', win, checkable=True)
        viewWebcams.setChecked(False)
        viewMenu.addAction(viewWebcams)
        
        roiMenu = menubar.addMenu('Roi')
        plotRoi = QAction('Open roi plot', win)
        roiMenu.addAction(plotRoi)
        
        saveAct.triggered.connect(lambda: self.save(analog_control_signals))
        loadAct.triggered.connect(lambda: self.load(analog_control_signals))
        saveAsAct.triggered.connect(lambda: self.save_as(analog_control_signals, win))
        openFromAct.triggered.connect(lambda: self.open_from(analog_control_signals, win))
        viewWebcams.toggled.connect(lambda: self.putWebcams(viewWebcams.isChecked()) )
        plotRoi.triggered.connect(self.openRoi)

    def save(self, aos):
        settings = QSettings('C:\\Users\\Usuario\\Documents\\control_app\\config.ini', QSettings.IniFormat)
        settings.beginGroup('Ventana')
        for ao in aos:
            spin_boxes = ao.spin_boxes
            
            for text, spinb in spin_boxes:
                settings.setValue(str(ao.name) + '_' + text, spinb.value())
                #print(spinb.value() )
        settings.endGroup()
        print('saving')
        
    def load(self, aos):
        settings = QSettings('C:\\Users\\Usuario\\Documents\\control_app\\config.ini', QSettings.IniFormat)
        settings.beginGroup('Ventana')
        for ao in aos:
            spin_boxes = ao.spin_boxes
            for text, spinb in spin_boxes:
                spin = settings.value(str(ao.name) + '_' + text)
                spinb.setValue( float(spin) )
        settings.endGroup()
    
    def first_load(self, aos):
        
        settings = QSettings('C:\\Users\\Usuario\\Documents\\control_app\\config.ini', QSettings.IniFormat)
        if not settings:
            print('Warning: no config.ini file in control_app folder. Pleace, be kindful and create one')
        return 0 
        
        settings.beginGroup('Ventana')
        for ao in aos:
            spin_boxes = ao.spin_boxes
            for text, spinb in spin_boxes:
                spin = settings.value(str(ao.name) + '_' + text)
                spinb.setValue( float(spin) )
        settings.endGroup()
        
        
    def save_as(self, aos, window):
        name = QFileDialog.getSaveFileName(window, 'Save File')
        
        file = open(name[0], 'w+')
        file.close()
        settings = QSettings(name[0], QSettings.IniFormat)
        settings.beginGroup('Ventana')
        for ao in aos:
            spin_boxes = ao.spin_boxes
            
            for text, spinb in spin_boxes:
                settings.setValue(str(ao.name) + '_' + text, spinb.value())
                #print(spinb.value() )
        settings.endGroup()
        print('saving to %s' % name[0])
        
    def open_from(self, aos, window):
        name = QFileDialog.getOpenFileName(window, 'Save File')
        
        settings = QSettings(name[0], QSettings.IniFormat)
        settings.beginGroup('Ventana')
        for ao in aos:
            spin_boxes = ao.spin_boxes
            for text, spinb in spin_boxes:
                spin = settings.value(str(ao.name) + '_' + text)
                spinb.setValue( float(spin) )
        settings.endGroup()
        
    def startWebcamsThread(self):
        exec(open('C:\\Users\\Usuario\\Documents\\control_app\\webcams.py').read())
        
    def putWebcams(self, checked):
        if checked:
            t_webcams = Thread(target=self.startWebcamsThread, args=())
            t_webcams.start()
        else:
            pass
        
    def openRoi(self):
        print('opening roi window')
        items = self.aosDicc.keys()
        item, okPressed = QInputDialog.getItem(self, "Get item","Color:", items, 0, False)
        if okPressed and item:
            ao = self.aosDicc[item]
            self.roiW = roiWindow(ao)
            self.roiW.w.show()
        else:
            print('Roi canceled')
    
    def startRoiThread(self, ao):
        self.roiW = roiWindow(ao)
        self.roiW.w.show()
    
    def getChoiceForRoi(self):
        items = self.aosDicc.keys()
        item, okPressed = QInputDialog.getItem(self, "Get item","Color:", items, 0, False)
        if okPressed and item:
            self.startRoiThread(item)
            return self.aosDicc[item]
    